/***************************************************************************
**
**  This file is part of millenium3.
**
**  millenium3 is free software: you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation, either version 3 of the License, or
**  (at your option) any later version.
**
**  millenium3 is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with Foobar.  If not, see <http://www.gnu.org/licenses/>
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2016-07-15
**  Copyright: 2016
**    Marc Wathelet (ISTerre, Grenoble, France)
**
***************************************************************************/

#include <fcntl.h>

#include "DailyFile.h"

/*!
  \class DailyFile DailyFile.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  Description of constructor still missing
*/
DailyFile::MidNightTimer::MidNightTimer(DailyFile * f)
  : Timer()
{
  TRACE;
  setInterval();
  _file=f;
}

/*!
  Description of destructor still missing
*/
bool DailyFile::MidNightTimer::exec()
{
  TRACE;
  _file->midNight();
  setInterval();
  return true;
}

/*!
  Description of destructor still missing
*/
void DailyFile::MidNightTimer::setInterval()
{
  TRACE;
  // Get shift between local time and UTC
  tzset();
  // Add one second to be sure that the day changed
  Timer::setInterval((86400-((time(0)-timezone+daylight*3600)%86400)+1)*1e3);
  Log::write(1, "Interval for midnigth=%i\n", Timer::interval());
}

/*!
  Description of constructor still missing
*/
DailyFile::DailyFile()
  : _timer(this)
{
  TRACE;
  _stream=0;
  _timer.start();
}

/*!
  Description of destructor still missing
*/
DailyFile::~DailyFile()
{
  TRACE;
  close();
}

bool DailyFile::open()
{
  TRACE;
  time_t tsec=time(0);
  tm * tstruct=localtime(&tsec);
  char * buf=new char[_baseName.size()+16];
  sprintf(buf, "%s_%4i%02i%02i.dat", _baseName.data(), tstruct->tm_year+1900, tstruct->tm_mon+1, tstruct->tm_mday);
  int fd=::open(buf, O_WRONLY | O_NONBLOCK | O_CREAT | O_APPEND, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
  if(fd>=0) {
    _stream=fdopen(fd, "a");
  }
  Log::write(0, "file '%s' open\n", buf);
  delete [] buf;
  return _stream;
}

void DailyFile::close()
{
  TRACE;
  fclose(_stream);
  _stream=0;
}

void DailyFile::midNight()
{
  TRACE;
  close();
  open();
}

void DailyFile::write(const char * cformat,...)
{
  TRACE;
  if(_stream) {
    va_list argptr;
    va_start(argptr, cformat);
    vfprintf(_stream, cformat, argptr);
    va_end(argptr);
    fflush(_stream);
  }
}
