/***************************************************************************
**
**  This file is part of millenium3.
**
**  millenium3 is free software: you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation, either version 3 of the License, or
**  (at your option) any later version.
**
**  millenium3 is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with Foobar.  If not, see <http://www.gnu.org/licenses/>
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2016-07-15
**  Copyright: 2016
**    Marc Wathelet (ISTerre, Grenoble, France)
**
***************************************************************************/

#ifndef DAILYFILE_H
#define DAILYFILE_H

#include <GpCoreTools.h>

class DailyFile
{
public:
  DailyFile();
  ~DailyFile();

  void setBaseName(const char * baseName) {_baseName=baseName;}
  bool open();
  void close();
  void midNight();

  void write(const char * cformat,...);
private:
  class MidNightTimer : public Timer
  {
  public:
    MidNightTimer(DailyFile * f);

    void setInterval();
    virtual bool exec();
  private:
    DailyFile * _file;
  };

  MidNightTimer _timer;
  FILE * _stream;
  std::string _baseName;
};

#endif // DAILYFILE_H

