/***************************************************************************
**
**  This file is part of millenium3.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2015-11-17
**  Copyright: 2015
**    Marc Wathelet (ISTerre, Grenoble, France)
**
***************************************************************************/

#ifndef MILLENIUMBUFFER_H
#define MILLENIUMBUFFER_H

#include <GpCoreTools.h>

#include "DailyFile.h"

class MilleniumBuffer : public DynamicBuffer
{
public:
  MilleniumBuffer(int fileDescriptor);

  int bytesAvailable(char *bytes, int bytesCount);
private:
  bool parse(char * buffer, int count);
  void saveStatus();
  void statusHeader();
  static char ascii2bin(const char c, bool &ok);

  union {
    char raw[16];
    struct {
      short int temperatureTamponHaut;
      short int temperatureTamponBas;
      short int temperatureSolaire;
      short int temperaturePoele;
      short int temperatureTamponMilieu;
      short int temperatureSejour;
      short int vitesseSolaire;
      char v_tampon:1;
      char c_poele:1;
      char c_plancher:1;
      char c_sdb:1;
      char res:1;
      char alarme:1;
      char c_sanitaire:1;
      char v_sanitaire:1;
      char c_solaire:1;
      char m_in_th:1;
      char m_in_tb:1;
      char m_out_th:1;
      char m_out_tb:1;
      char mu_chauffage:1;
      char mu_hors_gel:1;
      char mu_canicule:1;
    } values;
  } _data;

  DailyFile _outputFile;
};

#endif // MILLENIUMBUFFER_H
