/***************************************************************************
**
**  This file is part of millenium3.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program. If not, see <http://www.gnu.org/licenses/>.
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2015-11-17
**  Copyright: 2015

**
***************************************************************************/

#include <GpCoreTools.h>

#include "millenium3Version.h"
#include "millenium3InstallPath.h"
#include "MilleniumBuffer.h"
#include "RequestTimer.h"

PACKAGE_INFO(millenium3, MILLENIUM3)

ApplicationHelp * help();

int main(int argc, char ** argv)
{
  CoreApplication a(argc, argv, help);

  // Options

  // Check arguments
  int i, j=1;
  for (i=1; i<argc; i++) {
    const char * arg=argv[i];
    if (arg[0]=='-') {
      if(strcmp(arg, "-C")==0) {
        CoreApplication::checkOptionArg(i, argc, argv, true);
        chdir(argv[i]);
      } else {
        fprintf(stderr, "%s: bad option %s, see -help\n", a.applicationName(), argv[i]);
        CoreApplication::exit(2);
      }
    } else {
      argv[j++]=argv[i];
    }
  }
  if(j<argc) {
    argv[j]=0;
    argc=j;
  }

  EventLoop loop;
  Leds led;
  Serial * s=new Serial("/dev/serial/by-id/usb-STMicroelectronics_USB_to_Serial_bridge-if00", B115200, CS7, new MilleniumBuffer(0));
  s->connect();
  loop.addStream(s);
  RequestTimer * t=new RequestTimer(s);
  t->start();
  loop.exec();
  a.close();
  return 0;
}

ApplicationHelp * help()
{
  TRACE;
  ApplicationHelp * h=new ApplicationHelp;
  h->setOptionSummary( "[OPTIONS]");
  h->setComments("");
  h->addGroup("millenium3", "millenium3");
  h->addOption("-C <DIR>","Base directory for ouput data files");
  return h;
}
